setInfos(2, "Simple Timer", "A configurable timer, possibly random, with alarm signal and CD Trays opening at the end.", "Doti", "complete", 0xFFFFFF, "en", ["bondage","formale","forfemale"])


setImage("simpletimer/timer.png")
def valueNames = ["name","min","max","slow","feature"]
def valueTypes = ["string","integer","integer","integer","integer"]
def featureNames = ["No extra feature","10s countdown at the end","Bell every 10 seconds","Bell every minute","Bell every five minutes"]
def configs = []
def i = 0
while(loadString("simpletimer.config"+i+".name")!=null) {
	def config = [:]
	def j = 0
	for(def name:valueNames) {
		if(valueTypes[j]=="string")
			config[name] = loadString("simpletimer.config"+i+"."+name)
		else
			config[name] = loadInteger("simpletimer.config"+i+"."+name)
		j++
	}
	configs.add(config)
	i++
}

def config = null
if(configs.size()==0) {	
	show("How-to : you will configure the timer now, save your options (if you want), then start the timer.\nOptions : you will set a minimum and maximum time (script will choose randomly a duration between those values), and a reaction time at the end (max time to click on a button that will show after the bell rang).\n\nLet's configure\n\nNo previous configuration saved.");
	wait(3)
} else {
	def names = ["*** New ***"]
	for(def config2:configs) {
		names.add(config2["name"])
	}
	def n = getSelectedValue("Let's configure\n\nIf you want to use a previous saved configuration, choose it now (or choose \"new\").",	names);
	if(n!=0 && n<=names.size)
		config = configs[n-1]
}

if(config==null) {
	config = [:]
	config["min"] = getInteger("Choose the minimum amount of time (in seconds).\n\n"+
		"Total time will be randomly between minimum and maximum.", 5*60)
	config["max"] = getInteger("Choose the maximum amount of time (in seconds).", config["min"]+60)
	config["slow"] = getInteger("How much time (in seconds) you'll have to press 'stop' before being considered slow (sus perhaps punished for example) ?", 20)
	config["feature"] = getSelectedValue("Choose an extra feature.", featureNames)
	config["name"] = getString(
		"Summary : from "+config["min"]+"s to "+config["max"]+"s, then "+config["slow"]+"s is being slow, "+featureNames[config["feature"]]+".\n\n"+
		"Choose a name here, if you want to load back this configuration later (or let empty).","")
	if(config["name"]!="") {
		for(def name:valueNames)
			save("simpletimer.config"+configs.size()+"."+name,config[name])
		show(config["name"]+" saved")
	}
} else {
	def featureName = ""
	if(config["feature"]>=0 && featureNames.size)
		featureName = featureNames[config["feature"]]
	show("Summary : from "+config["min"]+"s to "+config["max"]+"s, then "+
		config["slow"]+"s is being slow, "+featureName+".\n\n")
}

wait(3)
def done = false
while(!done) {
	show("Testing sound ...")
	playBackgroundSound("bell.wav")
	done = !getBoolean("Bell just played. Do you want to hear it again ?")
}

wait(1);

done = false
while(!done) {
	showButton("Press to start")
	def totalTime = config["min"]+getRandom(config["max"]-config["min"])
	def t = 0
	def stopped = false
	while(t<totalTime && !stopped) {
		if(t<10 && totalTime>10) {
			show("Will show timer in "+(10-t)+" seconds...")
		} else {
			if(totalTime>=3600) {
 				def hours = (Integer)Math.floor((totalTime - t) / 3600)
				if(hours<10)
					hours = "0"+hours
 				def min = (Integer)Math.floor((totalTime - t) / 60) % 60
				if(min<10)
					min = "0"+min
				def sec = (totalTime - t) % 60
				if(sec<10)
					sec = "0"+sec
				show("<span style='font-size:90pt'>"+hours+":"+min+":"+sec+"</span>")
			} else if(totalTime>120) {
 				def min = (Integer)Math.floor((totalTime - t) / 60)
				if(min<10)
					min = "0"+min
				def sec = (totalTime - t) % 60
				if(sec<10)
					sec = "0"+sec
				show("<span style='font-size:100pt'>"+min+":"+sec+"</span>")
			} else {
				show("<span style='font-size:150pt'>"+(totalTime - t)+"</span>")
			}
			if(config["feature"]==1 && totalTime - t<=10)
				playBackgroundSound("bell.wav")			
			if(config["feature"]==2 && t%10==0)
				playBackgroundSound("bell.wav")
			if(config["feature"]==3 && t%60==0)
				playBackgroundSound("bell.wav")
			if(config["feature"]==4 && t%300==0)
				playBackgroundSound("bell.wav")
		}
		if(showButton("Started.... press to cancel", 1)<1)
			stopped = true
		t++
	}
	done = t==totalTime
}
show("Time !")
playBackgroundSound("bell.wav")
wait(0.3)
playBackgroundSound("bell.wav")
wait(0.3)
playBackgroundSound("bell.wav")
show("Time ! (opening CD Trays)")
openCdTrays()
def tooSlow = false
if(showButton("End (press this in less than "+config["slow"]+"s !)",config["slow"])==config["slow"]) {
	playBackgroundSound("bell.wav")
	wait(0.3)
	playBackgroundSound("bell.wav")	
	while(showButton("End (press this in less than "+config["slow"]+"s !)", 60)==60) {
		playBackgroundSound("bell.wav")
		wait(0.3)
		playBackgroundSound("bell.wav")	
	}
	show("You were too slow, you should ask for a punishment !\n\nGoodbye")
} else {
	show("Goodbye")
}

setImage(null)

// This script, from http://ss.deviatenow.com, is protected by this licence : 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/
// Picture is the breast cancer campaign pink timer ; donate and make a difference, http://www.breastcancercampaign.org/
